//+---------------------------------------------------------------------+ 
//|                                                             TTF.mq5 | 
//|                                        Copyright  2005, Nick Bilak | 
//|                                                 beluck[at]gmail.com | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
//----  
#property copyright "Copyright  2005, Nick Bilak"
//----  
#property link      "beluck[at]gmail.com"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----        
#property indicator_buffers 2
//----    
#property indicator_plots   2
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----        DarkOrchid 
#property indicator_color1  clrDarkOrchid
//----   1 -  
#property indicator_style1  STYLE_SOLID
//----    1  1
#property indicator_width1  1
//----    
#property indicator_label1  "TTF"
//+----------------------------------------------+
//|     Signal       |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_LINE
//----        Magenta 
#property indicator_color2  clrMagenta
//----   2 -  
#property indicator_style2  STYLE_SOLID
//----    2  1
#property indicator_width2  1
//----    
#property indicator_label2  "Signal"
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1 0.0
#property indicator_levelcolor clrGray
#property indicator_levelstyle STYLE_DASHDOTDOT
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint TTFbars=8;      //    
input int TopLine=75;      //    
input int BottomLine=-75;  //    
input uint T3Period=14;    //  T3 
input double b_=70;        //  b x100
input int Shift=0;         //       
//+----------------------------------------------+
//----   ,    
//      
double TTFBuffer[];
double SignalBuffer[];
//----      
int CP_Handle;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//    CT3                                              |
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_total=int(2*TTFbars+1);

//----      
   SetIndexBuffer(0,TTFBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----       1  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(TTFBuffer,true);

//----      
   SetIndexBuffer(1,SignalBuffer,INDICATOR_DATA);
//----    2    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//----       2  min_rates_total
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(SignalBuffer,true);

//----      
   string shortname;
   StringConcatenate(shortname,"TTF(",TTFbars,", ",Shift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(RESET);

//----    
   int limit,bar,maxbar;
   double HHRecent,LLOlder,HHOlder,LLRecent,BuyPower,SellPower,TTF,T3TTF;

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-1-min_rates_total; //      
     }
   else limit=rates_total-prev_calculated; //      
//----   
   maxbar=rates_total-2-min_rates_total;
   
//----    T3   T3Series_Cls.mqh
   static CT3 T3_;
   
//----         
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      HHRecent=high[ArrayMaximum(high,bar,TTFbars)];
      LLRecent=low[ArrayMinimum(low,bar,TTFbars)];
      HHOlder=high[ArrayMaximum(high,bar+TTFbars,TTFbars)];
      LLOlder=low[ArrayMinimum(low,bar+TTFbars,TTFbars)];
      //----
      BuyPower=HHRecent-LLOlder;
      SellPower=HHOlder-LLRecent;
      TTF=(BuyPower-SellPower)/(0.5*(BuyPower+SellPower))*100;    
      T3TTF=T3_.T3Series(maxbar,prev_calculated,rates_total,0,b_,T3Period,TTF,bar,true);
      TTFBuffer[bar]=T3TTF;
      //----
      if (T3TTF>=0) SignalBuffer[bar]=TopLine;
      else SignalBuffer[bar]=BottomLine;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
